Subject: Re: [MOBILE-IP] Consensus for the extensions template defined in MIER

From: Patrice Calhoun <[email-masked]>
Date: Tue, 11 Jan 2000 21:58:57 -0800

I do have some serious concerns about such a statement. It isn't clear
that we are really running out of extensions at the moment, and although
I agree that we will someday, requiring this for ALL future extensions
MAY be self-defeating. There are many extensions that are unique in
nature, and are not necessarily subject to being "grouped" in a MIER
approach.

PatC
>
>The MIER draft (draft-ietf-mobileip-mier-00.txt) states that all new
>extensions defined for Mobile IP in the future MUST follow the
>template that is specified in the document.
>The difference from the existing definition specified in RFC2002 is
>that adds a subtype field and the length field is increased two
>octets.
>
>If you have concerns or disagree with this proposal, please express it
>on the mailing list by the end of this week.
>
>-Basavaraj Patil

---

From: "N. Asokan" <[email-masked]>
Date: Thu, 13 Jan 2000 10:09:29 +0200

Jouni Malinen <[email-masked]> wrote:
[...]
> Doesn't this break the compatibility with RFC 2002 compliant
> implementations completely as far as new skippable extensions are
> concerned? The two octet length field could be used in non-skippable
> extensions as they should cause the whole message to be silently
> discarded (if the receiver does not recognize them), but I didn't see
> that kind of requirement in the draft.

This is clearly a problem.  I already pointed this out several times, e.g.
in message 74 of the December archives:
http://standards.nortelnetworks.com/scripts/wa.exe?A2=ind9912&L=mobile-ip&O=D&P=8132

| [...]
| Additional comments on the new MIER-01 draft (from a mail I sent to
| Mohamed et al earlier today):
| > - if you use two bytes for the length field, all MIER extensions have
| >   to be unskippable (for backward compatibility).  This wouldn't be
| >   a good idea, esp. if it is mandated that all new extensions have
| >   to be in MIER style.
| >
| >   I'd suggest that you propose two types of MIER extensions: regular
| >   and "unskippable jumbo" extensions.  Regular extensions use only
| >   1 byte length field and can be either skippable or unskippable.
| >   "Unskippable jumbo" extensions have 2 byte length fields and
| >   must be unskippable.
| [...]

Regards,
- Asokan

---
N. Asokan, Communication Systems Lab, Nokia Research Center, Helsinki

---

From: Mohamed Khalil <[email-masked]>
Date: Thu, 13 Jan 2000 09:15:35 -0600

> -----Original Message-----
> From: Jouni Malinen [SMTP:[email-masked]]
> Sent: Wednesday, January 12, 2000 12:45 AM
> To:   [email-masked]
> Subject:      Re: [MOBILE-IP] Consensus for the extensions template
> defined in MIER
>
> On Tue, Jan 11, 2000 at 08:58:48PM -0600, Basavaraj Patil wrote:
>
> This would mean that all the new extensions (even skippable) would be
> required to use the proposed extension format. An old implementation
> not knowing of the MIER draft would be unable to parse the extensions
> as the length field would be in a different place and of different
> size. So messages with a new _skippable_ extension would be dropped.
>
> Is this kind of compatibility breaking approach all right? Are we
> trying to make a need for some complicated method of finding out
> whether each MN, FA, and HA on the path support MIER before an agent
> could send any new skippable extensions? Or should the agent try once
> and after some time try again without the MIER type extension? I'm not
> welcoming this kind of complexity. It would be easier to change the
> extension format in RFC 2002bis and forget about the compatibility,
> but I don't think it is acceptable to break the compatibility this way
> with RFC 2002.
>
> I do, however, think, that subtyping of extensions would be a good
> thing. Subtyping can be done with one byte length field in the
> original place for the skippable extensions so that the compatibility
> is maintained. In addition, I don't see any good enough reason for
> requiring that every new extension must use subtyping.
        [MK>]   Your point of view is completely valid, and i think your
suggestion about having another template  for skippable extension where the
location of the length field is preserved  is a good suggestion and will be
taken in consideration in the next version of this draft. Once again, thanks
for your constructive comments.

        --

> --
> Jouni Malinen
        Mohamed Khalil

---

From: Mohamed Khalil <[email-masked]>
Date: Thu, 13 Jan 2000 09:43:01 -0600

Hi Asokan,

> From: N. Asokan [SMTP:[email-masked]]
> Sent: Thursday, January 13, 2000 2:09 AM
        [MK>] Your concern is completely valid. I read your message again

        Asokan's Old Message>
        >   I'd suggest that you propose two types of MIER extensions:
regular
        >   and "unskippable jumbo" extensions.  Regular extensions use only
        >   1 byte length field and can be either skippable or unskippable.
        >   "Unskippable jumbo" extensions have 2 byte length fields and
        >   must be unskippable.

        Your proposal  is very similar to  Jouni proposal.  We will take
that in consideration in next revision.
        Thank you for your comments.